VERSION 5.00
Object = "{2067B997-E36D-11D1-9A3E-0000E8DD8A37}#1.0#0"; "ICClient.ocx"
Object = "{58525D98-4716-11D1-BABB-0C0909C10000}#13.0#0"; "RegSet.ocx"
Object = "{5DA62B65-0D48-11D2-A6E3-00400541EFEE}#1.0#0"; "Svcit.ocx"
Begin VB.Form Form1 
   BorderStyle     =   1  'Fixed Single
   Caption         =   "License Manager"
   ClientHeight    =   795
   ClientLeft      =   45
   ClientTop       =   330
   ClientWidth     =   2355
   Icon            =   "LicenceManager.frx":0000
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   795
   ScaleWidth      =   2355
   StartUpPosition =   3  'Windows Default
   Begin ICClient.ICClient ICClient1 
      Left            =   120
      OleObjectBlob   =   "LicenceManager.frx":0442
      Top             =   120
   End
   Begin SVCITLib.SvcIt SvcIt1 
      Height          =   480
      Left            =   1560
      TabIndex        =   0
      Top             =   120
      Visible         =   0   'False
      Width           =   480
      _Version        =   65536
      _ExtentX        =   847
      _ExtentY        =   847
      _StockProps     =   0
      ServiceName     =   "CivSolLM"
      DisplayName     =   "Civil Solutions License Manager"
      Dependencies    =   "InterCom"
      MachineName     =   ""
      ServiceExe      =   ""
      StartType       =   0
      Interact        =   0   'False
      Mode            =   0
   End
   Begin Karland_RegSet.RegSettings RegSettings1 
      Left            =   720
      Top             =   120
      _ExtentX        =   926
      _ExtentY        =   926
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False

Option Explicit
Option Base 0

' these variables are the equivilent of properties of the form
Dim UserCount As Integer
Dim ConnectedList() As Integer
Dim EvalVersion As Boolean
Dim llRunningNT As Boolean


Private Sub Form_Load()

    llRunningNT = (Environ("OS") = "Windows_NT")

    If Command = "-install" Then
    
        If llRunningNT Then
            SvcIt1.Interact = True
        End If
        ConfigDlg.Show vbModal
        
    
    ElseIf Command = "-uninstall" Then
    
        If llRunningNT Then
            SvcIt1.Remove
            
            ' if we've removed the service sucessfully, then remove the appropriate registry keys
            If Not SvcIt1.IsInstalled Then
                Dim lcCompositeKey As String
                lcCompositeKey = BASEKEY & SEPARATOR & APPNAME & SEPARATOR & SETTINGS
                With RegSettings1
                    .RegDelete HKLM, lcCompositeKey
                End With
    
            End If
        End If
    
    ElseIf Command = "" Then
    
        If Not llRunningNT Then
            Call StartLicenseManager
            Me.WindowState = vbMinimized
            Me.Visible = True
        End If
    
        GoTo NoError:
    Else
    
        WriteError LoadResString(RS_UNKNOWNPARAMETER) & " " & Command
    
    End If
    
loaderror:
    Unload Me

NoError:

End Sub

Sub WriteError(ErrorMessage As String, Optional ErrorType As Long = ERRORTYPE_WARNING)
    If llRunningNT Then
        With SvcIt1
            .LogEvent ErrorMessage, ErrorType
        End With
    Else
        MsgBox ErrorMessage
    End If
End Sub

Function ValidateKey(tcLicenseKey As String) As Integer
    
    Dim lnUserCount As Integer
    lnUserCount = 0
    
    ' This is a simple en/decryption routine for testing purposes
    ' if the length is not right, it's obviously not valid
    If Len(tcLicenseKey) <> 65 Then
        GoTo KeyError:
    End If
    
    ' The user count is stored in the string in 4 bytes
    lnUserCount = (Asc(Mid$(tcLicenseKey, 4, 1)) - 1) * 256 ^ 3 + _
                    (Asc(Mid$(tcLicenseKey, 19, 1)) - 1) * 256 ^ 2 + _
                    (Asc(Mid$(tcLicenseKey, 58, 1)) - 1) * 256 ^ 1 + _
                    (Asc(Mid$(tcLicenseKey, 12, 1)) - 1) * 256 ^ 0
    
    EvalVersion = Mid$(tcLicenseKey, 37, 1) <> "T"

    GoTo NoKeyError:
    
KeyError:
    lnUserCount = 0
    
NoKeyError:
    
    ValidateKey = lnUserCount
    
End Function

Private Sub ICClient1_OnEvent(ByVal Client As Long, ByVal EventTriggered As String, ByVal Data As Variant)
    If Data = -1 Then
        GoTo BadClient:
    End If
    
    With ICClient1
    
        Select Case EventTriggered
        Case "SYSEVT_CONNECT"
            
            Dim lcUser As String, lcComputer As String, lcHost As String, lcDescriptor As String
            Dim lnPort As Long
            Dim luDetails As Variant, luEvents As Variant
            Dim ldConnectTime As Date
            .GetClientInfo Data, lcUser, lcComputer, lcHost, lnPort, lcDescriptor, luDetails, ldConnectTime, luEvents

            ' If this is a LM_ type connection, and there are still some licenses left, then
            ' add it to the list of connected users
            If UCase$(Left$(lcDescriptor, 3)) = "LM_" Then
                If UBound(ConnectedList) < UserCount Then
                    If Not EvalVersion Then
                        .SendMessage Data, "ACCEPTED", ""
                    Else
                        .SendMessage Data, "EVAL", ""
                    End If
                    ReDim Preserve ConnectedList(UBound(ConnectedList) + 1)
                    ConnectedList(UBound(ConnectedList)) = Data
                Else
                     .SendMessage Data, "REJECTED", ""
                End If
            End If
        Case "SYSEVT_DISCONNECT"
            Dim OuterCounter As Integer, InnerCounter As Integer
            For OuterCounter = 1 To UBound(ConnectedList)
                If ConnectedList(OuterCounter) = Data Then
                    ' we've found the disconnecting user and should remove them from the list
                    ' move the users below up and re-dimension the array
                    For InnerCounter = OuterCounter To UBound(ConnectedList) - 1
                        ConnectedList(InnerCounter) = ConnectedList(InnerCounter + 1)
                    Next InnerCounter
                    ReDim Preserve ConnectedList(UBound(ConnectedList) - 1)
                    
                    ' found it, so get out of the outer loop
                    Exit For
                End If
            Next OuterCounter
        Case Else
        End Select
    
    End With
    
BadClient:
    
End Sub

Private Sub form_queryunload(cancel As Integer, unloadmode As Integer)
    ' send a message to the connected users that the license manager is going down
    With ICClient1
        If .Connected() Then
            .Trigger "LMDOWN", "", False
        End If
    End With
End Sub

Private Sub SvcIt1_Start(ByVal sParams As String)

    Call StartLicenseManager
    
End Sub

Private Sub SvcIt1_Shutdown()
    SvcIt1.Stop
    Unload Me
End Sub

Private Sub StartLicenseManager()
    With RegSettings1
        Dim lcCompositeKey As String
        lcCompositeKey = BASEKEY & SEPARATOR & APPNAME & SEPARATOR & SETTINGS
        
        'ConnectedCount = 0
        UserCount = 0
        ReDim ConnectedList(0)
    
        ' get the details from the registry
        Dim lcServerHost As String, lcDescriptor As String, lcLicenseKey As String
    
        lcServerHost = .QueryValue(HKLM, lcCompositeKey, "ServerHost")
    
        ' check for a "" return value which means that the key doesn't exist
        If lcServerHost = "" Then
            WriteError LoadResString(RS_SERVERHOSTKEYNOTDEFINED) & LoadResString(RS_RERUNLICENSEMANAGER)
            GoTo StartError:
        End If
        lcDescriptor = .QueryValue(HKLM, lcCompositeKey, "Descriptor")
    
        ' read the license key from the settings
        lcLicenseKey = .QueryValue(HKLM, lcCompositeKey, LICENSEKEY)
        ' check for a "" return value which means that the key doesn't exist
        If lcLicenseKey = "" Then
            WriteError LoadResString(RS_LICENSEKEYNOTDEFINED) & LoadResString(RS_RERUNLICENSEMANAGER)
            GoTo StartError:
        End If
    End With
    
    ' Decrypt and verify the license key
    UserCount = ValidateKey(lcLicenseKey)
    
    If UserCount < 1 Then
        WriteError LoadResString(RS_LICENSEEXPIREDORINVALID) & LoadResString(RS_CONTACTSYSTEMADMIN)
        GoTo StartError:
    '    Else
    '        MsgBox UserCount, , "User Count"
    End If
    
    
    ' initialise the messaging client and connect
    With ICClient1
        .ServerHost = lcServerHost
        .Descriptor = "License Manager"
        
        .Connect
        If .Connected() Then
            .Subscribe "SYSEVT_CONNECT"
            .Subscribe "SYSEVT_DISCONNECT"
            ' subscribe to the LMDOWN event to create it
            .Subscribe "LMDOWN"
        Else
            
            GoTo StartError:
            
        End If
        
    End With
    
GoTo NoError:

StartError:
    WriteError LoadResString(RS_ABNORMALSHUTDOWN), ERRORTYPE_ERROR
    If llRunningNT Then
        SvcIt1.Abort 0, RS_ABNORMALSHUTDOWN
    End If
    End

NoError:


End Sub
