*---------- Location Section ----------
*} Program: Enabler.prg
*--------------------------------------
*) Description: 6.0 Class Browser AddIn that enables and disables
*)  the AddInfo addin
*---------- Usage Section -------------
*$ Parameters: toBrowser - instance of class browser calling this addin
*$ Usage: oBrowser.AddIn(cName, cProgram)
*$ Example: _oBrowser.AddIn('AddInfo', 'c:\vfptools\Enabler.prg')
*$ Returns: LOGICAL 
*--------------------------------------

#INCLUDE addinfo.h

********
******** Parameters
********
lparameters toBrowser

local lnOldWorkArea 
local lnRecordNumber 
local lcMenuPath

lnOldWorkArea = select(cc_CURRENT_WORKAREA)
SELECT browser
lnRecordNumber = recno()

* Initial registration is done by a setup program
locate for upper(alltrim(TYPE))==cc_BROWSER_TYPE_ADDIN ;
			and upper(alltrim(ID))==cc_BROWSER_ID_METHOD ;
			and upper(alltrim(NAME))==cc_BROWSER_NAME_MAINADDIN;
			and upper(alltrim(METHOD))==cc_BROWSER_METHOD_MAINADDIN
if not found()
	* Could not find our addin, so put things back the way
	* we found them and get out
	goto lnRecordNumber
	select (lnOldWorkArea)
	return
endif


if upper(alltrim(USER1))==cc_BROWSER_USER1_ENABLED ;
	or empty(USER1)
	* The addin is current enabled, so diable it
	replace USER1 with cc_BROWSER_USER1_DISABLED

		
	* find the old menu addin and unregister it
	locate for upper(alltrim(TYPE))==cc_BROWSER_TYPE_ADDIN ;
			and upper(alltrim(ID))==cc_BROWSER_ID_MENU ;
			and alltrim(NAME)$cc_BROWSER_NAME_DISABLEADDIN ;
			and len(alltrim(NAME))=len(cc_BROWSER_NAME_DISABLEADDIN)
	if found()
		lcMenuPath = alltrim(PROGRAM)
		tobrowser.addin(cc_BROWSER_NAME_DISABLEADDIN, ;
			.NULL.)
		* Change the text of the menu by registering again with
		* a different name
		tobrowser.addin(cc_BROWSER_NAME_ENABLEADDIN, ;
			lcMenuPath)
	else
		goto lnRecordNumber
		select (lnOldWorkArea)
		return
	endif
	* Done with the cursor, so put things back
	goto lnRecordNumber
	select (lnOldWorkArea)
	toBrowser.RefreshMembers()
else
	* the addin is currently disabled, so enable it
	replace USER1 with cc_BROWSER_USER1_ENABLED


	* find the old menu addin and unregister it
	locate for upper(alltrim(TYPE))==cc_BROWSER_TYPE_ADDIN ;
			and upper(alltrim(ID))==cc_BROWSER_ID_MENU ;
			and alltrim(NAME)$cc_BROWSER_NAME_ENABLEADDIN ;
			and len(alltrim(NAME))=len(cc_BROWSER_NAME_ENABLEADDIN)
	if found()
		lcMenuPath = alltrim(PROGRAM)
		tobrowser.addin(cc_BROWSER_NAME_ENABLEADDIN, ;
			.NULL.)
		* Change the text of the menu by registering again with
		* a different name
		tobrowser.addin(cc_BROWSER_NAME_DISABLEADDIN, ;
			lcMenuPath)
	else
		goto lnRecordNumber
		select (lnOldWorkArea)
		return
	endif
	* Done with the cursor, so put things back
	goto lnRecordNumber
	select (lnOldWorkArea)

	* Since we are enabled now, run our addin please
	toBrowser.DoAddIn(cc_BROWSER_NAME_MAINADDIN)
endif	


*---------- Maintenance Section -------
*@ Precondition Invariants: 
*@ Post-condition Invariants: 
*? To Do:
*= Methods Called:
** Process: 
*^ Change Log: 
*^ Created 20:03:57 Friday, March 19, 1999 - NDD
*---------- (c) Copyright 1999 ----
*   Company: East West Technology Services, Inc.
*   Programmer: Nick Drochak
*   Internet: ndrochak@ewc.co.jp
*   Phone: 81-3-3222-5912
*--------------------------------------